/**
This code is part of the Arc-flow 0-1CSP Solver.

Copyright (C) 2013, Filipe Brandao
Faculdade de Ciencias, Universidade do Porto
Porto, Portugal. All rights reserved. E-mail: <fdabrandao@dcc.fc.up.pt>.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/
#include "csp01flow.hpp"
#include <cstdio>
#include <cassert>
#include <cstring>
using namespace std;

int main(int argc, char *argv[]){     
    setvbuf(stdout, NULL, _IONBF, 0);    
    
    assert(argc >= 2 && argc <= 3);    
    
    FILE *fin = fopen(argv[1], "r");
    assert(fin != NULL);
         
    Instance inst;
    assert(fscanf(fin, "%d", &inst.W)==1);
    assert(fscanf(fin, "%d", &inst.m)==1);
    
    inst.items.resize(inst.m);
    for(int i = 0; i < inst.m; i++)
        assert(fscanf(fin, "%d%d", &inst.items[i].w, &inst.items[i].b)==2);    
    
    Arcflow graph(inst);

    char vtype = 'C';
    if(argc == 3) {
        assert(strlen(argv[2])==1);
        vtype = argv[2][0];
        assert(vtype == 'C' || vtype == 'I');
    }   
    
    graph.finalize();
    graph.solve(vtype); 

    fclose(fin);
    return 0;
}

